#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

const int mod = 10007;
const int maxN = 15;
const int maxM = 50;
const int maxDvaNaN = 40000;

int n, m, dvaNaN, res;
int k[maxM];
int moguceSlovo[maxM][maxN];
int potrebno[maxN];
int koliko[2][maxDvaNaN];

bool parno[maxN];

void probaj(int i){
     if (i == m) {
        bool ok = true;
        for (int j = 0; j < n; j++)
            if (((potrebno[j] == 0) && (!parno[j])) || ((potrebno[j] == 1) && (parno[j]))) 
               ok = false;
        if (ok) res++;
     }
     else {
          for (int j = 0; j < k[i]; j++) {
              int pom = moguceSlovo[i][j];
              parno[pom] = !parno[pom];
              probaj(i + 1);
              parno[pom] = !parno[pom];    
          }
     }
}

int main() {
    freopen("igrica.in", "r", stdin);
    scanf("%d%d", &n, &m);   
    for (int i = 0; i < m; i++) {
        k[i] = 0;
        for (int j = 0; j < n; j++) {
            int pom;
            scanf("%d", &pom);
            if (pom == 1) {
               moguceSlovo[i][k[i]] = j;
               k[i]++;       
            }
        }
    }
    for (int i = 0; i < n; i++) 
        scanf("%d", &(potrebno[i]));
    
    for (int i = 0; i < n; i++) parno[i] = true;
    
    res = 0;
    probaj(0);
    res %= mod;
    
    freopen("igrica.out", "w", stdout);
    printf("%d\n", res);
    return 0;
}
