/*
  Author: Slobodan Mitrovic
  e-mail: boba5555@gmail.com
  date: 25.05.2009.
  Complexity: O(query_N + query_Q * max_v) - in this case, max_v = 200000
*/
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#define ffor(_a,_f,_t) for(int _a=(_f),__t=(_t);_a<__t;_a++)
#define all(_v) (_v).begin() , (_v).end()
#define sz size()
#define pb push_back
#define SET(__set, val) memset(__set, val, sizeof(__set))
#define FOR(__i, __n) ffor (__i, 0, __n)

using namespace std;

const int MAXVAL = 200000;

int A[MAXVAL + 1];

int main(){
    freopen("baloni.in", "rt", stdin);
    freopen("baloni.out", "wt", stdout);
    int M, v, ret, canTake;
    char op;
    scanf("%d", &M);
    SET(A, 0);
    FOR (i, M){
    scanf("\n%c %d", &op, &v);
    if (op == 'N')
      A[v]++;
    else{
      ret = 0;
      ffor (i, 1, MAXVAL + 1)
        if (A[i] > 0){
          canTake = min(A[i], v / i);
          ret += canTake;
          if (canTake < A[i])
            break;
          v -= canTake * i;
        }
      printf("%d\n", ret);
    }
  }
  return 0;
}
